std::messages< _CharT > Class Template Reference
Locales
Inheritance diagram for std::messages< _CharT >:
[legend]

## Public Types

typedef int | catalog
typedef _CharT | char_type
typedef basic_string< _CharT > | string_type

## Public Member Functions

| messages (size_t __refs=0)
| messages (__c_locale __cloc, const char *__s, size_t __refs=0)
void | close (catalog __c) const
string_type | get (catalog __c, int __set, int __msgid, const string_type &__s) const
catalog | open (const basic_string< char > &__s, const locale &__loc) const
catalog | open (const basic_string< char > &, const locale &, const char *) const

## Static Public Attributes

static locale::id | id

## Protected Member Functions

virtual | ~messages ()
string_type | _M_convert_from_char (char *) const
char * | _M_convert_to_char (const string_type &__msg) const
template<>
void | do_close (catalog) const
template<>
void | do_close (catalog) const
virtual void | do_close (catalog) const
virtual string_type | do_get (catalog, int, int, const string_type &__dfault) const
template<>
string | do_get (catalog, int, int, const string &) const
template<>
wstring | do_get (catalog, int, int, const wstring &) const
template<>
messages< char >::catalog | do_open (const basic_string< char > &, const locale &) const
template<>
messages< wchar_t >::catalog | do_open (const basic_string< char > &, const locale &) const
virtual catalog | do_open (const basic_string< char > &, const locale &) const

## Static Protected Member Functions

static __c_locale | _S_clone_c_locale (__c_locale &__cloc) throw ()
static void | _S_create_c_locale (__c_locale &__cloc, const char *__s, __c_locale __old=0)
static void | _S_destroy_c_locale (__c_locale &__cloc)
static __c_locale | _S_get_c_locale ()
static const char * | _S_get_c_name () throw ()
static __c_locale | _S_lc_ctype_c_locale (__c_locale __cloc, const char *__s)

## Protected Attributes

__c_locale | _M_c_locale_messages
const char * | _M_name_messages

## Detailed Description

### template<typename _CharT>
class std::messages< _CharT >

Primary class template messages.

This facet encapsulates the code to retrieve messages from message catalogs. The only thing defined by the standard for this facet is the interface. All underlying functionality is implementation-defined.

This library currently implements 3 versions of the message facet. The first version (gnu) is a wrapper around gettext, provided by libintl. The second version (ieee) is a wrapper around catgets. The final version (default) does no actual translation. These implementations are only provided for char and wchar_t instantiations.

The messages template uses protected virtual functions to provide the actual results. The public accessors forward the call to the virtual functions. These virtual functions are hooks for developers to implement the behavior they require from the messages facet.

Definition at line 1797 of file locale_facets_nonio.h.

## Member Typedef Documentation

## char_type

template<typename _CharT>

typedef _CharT std::messages< _CharT >::char_type

Public typedefs.

Definition at line 1803 of file locale_facets_nonio.h.

## string_type

template<typename _CharT>

typedef basic_string<_CharT> std::messages< _CharT >::string_type

Public typedefs.

Definition at line 1804 of file locale_facets_nonio.h.

## Constructor & Destructor Documentation

## messages() [1/2]

template<typename _CharT >

std::messages< _CharT >::messages | ( | size_t | __refs = `0` | ) |

explicit

Constructor performs initialization.

This is the constructor provided by the standard.

Parameters

  __refs | Passed to the base facet class.

Definition at line 44 of file messages_members.h.

## messages() [2/2]

template<typename _CharT >

std::messages< _CharT >::messages | ( | __c_locale | __cloc,
|  | const char * | __s,
|  | size_t | __refs = `0`
| ) |  |

explicit

Internal constructor. Not for general use.

This is a constructor for use by the library itself to set up new locales.

Parameters

  __cloc | The C locale.
  __s | The name of a locale.
  __refs | Refcount to pass to the base class.

Definition at line 50 of file messages_members.h.

References std::basic_string< _CharT, _Traits, _Alloc >::c_str().

## ~messages()

template<typename _CharT >

std::messages< _CharT >::~messages | ( |  | ) |

protected virtual

Destructor.

Definition at line 79 of file messages_members.h.

References std::basic_string< _CharT, _Traits, _Alloc >::c_str().

## Member Function Documentation

## do_get()

template<>

string std::messages< char >::do_get | ( | catalog | ,
|  | int | ,
|  | int | ,
|  | const string & |
| ) |  | const

protected

Specializations for required instantiations.

## Member Data Documentation

## id

template<typename _CharT>

locale::id std::messages< _CharT >::id

static

Numpunct facet id.

Definition at line 1815 of file locale_facets_nonio.h.

The documentation for this class was generated from the following files:

- locale_facets_nonio.h
- messages_members.h